<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>PrepRequestProcessor.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server</a> &gt; <span class="el_source">PrepRequestProcessor.java</span></div><h1>PrepRequestProcessor.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.nio.ByteBuffer;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.ListIterator;
import java.util.Locale;
import java.util.Set;
import java.util.concurrent.LinkedBlockingQueue;

import org.apache.jute.Record;
import org.apache.jute.BinaryOutputArchive;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.apache.zookeeper.CreateMode;
import org.apache.zookeeper.KeeperException;
import org.apache.zookeeper.KeeperException.BadArgumentsException;
import org.apache.zookeeper.MultiTransactionRecord;
import org.apache.zookeeper.Op;
import org.apache.zookeeper.ZooDefs;
import org.apache.zookeeper.KeeperException.Code;
import org.apache.zookeeper.ZooDefs.OpCode;
import org.apache.zookeeper.common.PathUtils;
import org.apache.zookeeper.data.ACL;
import org.apache.zookeeper.data.Id;
import org.apache.zookeeper.data.StatPersisted;
import org.apache.zookeeper.proto.CreateRequest;
import org.apache.zookeeper.proto.DeleteRequest;
import org.apache.zookeeper.proto.SetACLRequest;
import org.apache.zookeeper.proto.SetDataRequest;
import org.apache.zookeeper.proto.CheckVersionRequest;
import org.apache.zookeeper.server.ZooKeeperServer.ChangeRecord;
import org.apache.zookeeper.server.auth.AuthenticationProvider;
import org.apache.zookeeper.server.auth.ProviderRegistry;
import org.apache.zookeeper.server.quorum.Leader.XidRolloverException;
import org.apache.zookeeper.txn.CreateSessionTxn;
import org.apache.zookeeper.txn.CreateTxn;
import org.apache.zookeeper.txn.DeleteTxn;
import org.apache.zookeeper.txn.ErrorTxn;
import org.apache.zookeeper.txn.SetACLTxn;
import org.apache.zookeeper.txn.SetDataTxn;
import org.apache.zookeeper.txn.CheckVersionTxn;
import org.apache.zookeeper.txn.Txn;
import org.apache.zookeeper.txn.MultiTxn;
import org.apache.zookeeper.txn.TxnHeader;

/**
 * This request processor is generally at the start of a RequestProcessor
 * change. It sets up any transactions associated with requests that change the
 * state of the system. It counts on ZooKeeperServer to update
 * outstandingRequests, so that it can take into account transactions that are
 * in the queue to be applied when generating a transaction.
 */
public class PrepRequestProcessor extends ZooKeeperCriticalThread implements
        RequestProcessor {
<span class="fc" id="L81">    private static final Logger LOG = LoggerFactory.getLogger(PrepRequestProcessor.class);</span>

    static boolean skipACL;
    static {
<span class="fc" id="L85">        skipACL = System.getProperty(&quot;zookeeper.skipACL&quot;, &quot;no&quot;).equals(&quot;yes&quot;);</span>
<span class="pc bpc" id="L86" title="1 of 2 branches missed.">        if (skipACL) {</span>
<span class="nc" id="L87">            LOG.info(&quot;zookeeper.skipACL==\&quot;yes\&quot;, ACL checks will be skipped&quot;);</span>
        }
    }

    /**
     * this is only for testing purposes.
     * should never be useed otherwise
     */
<span class="fc" id="L95">    private static  boolean failCreate = false;</span>

<span class="fc" id="L97">    LinkedBlockingQueue&lt;Request&gt; submittedRequests = new LinkedBlockingQueue&lt;Request&gt;();</span>

    RequestProcessor nextProcessor;

    ZooKeeperServer zks;

    public PrepRequestProcessor(ZooKeeperServer zks,
            RequestProcessor nextProcessor) {
<span class="fc" id="L105">        super(&quot;ProcessThread(sid:&quot; + zks.getServerId() + &quot; cport:&quot;</span>
<span class="fc" id="L106">                + zks.getClientPort() + &quot;):&quot;, zks.getZooKeeperServerListener());</span>
<span class="fc" id="L107">        this.nextProcessor = nextProcessor;</span>
<span class="fc" id="L108">        this.zks = zks;</span>
<span class="fc" id="L109">    }</span>

    /**
     * method for tests to set failCreate
     * @param b
     */
    public static void setFailCreate(boolean b) {
<span class="fc" id="L116">        failCreate = b;</span>
<span class="fc" id="L117">    }</span>
    @Override
    public void run() {
        try {
            while (true) {
<span class="fc" id="L122">                Request request = submittedRequests.take();</span>
<span class="fc" id="L123">                long traceMask = ZooTrace.CLIENT_REQUEST_TRACE_MASK;</span>
<span class="fc bfc" id="L124" title="All 2 branches covered.">                if (request.type == OpCode.ping) {</span>
<span class="fc" id="L125">                    traceMask = ZooTrace.CLIENT_PING_TRACE_MASK;</span>
                }
<span class="pc bpc" id="L127" title="1 of 2 branches missed.">                if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L128">                    ZooTrace.logRequest(LOG, traceMask, 'P', request, &quot;&quot;);</span>
                }
<span class="fc bfc" id="L130" title="All 2 branches covered.">                if (Request.requestOfDeath == request) {</span>
<span class="fc" id="L131">                    break;</span>
                }
<span class="fc" id="L133">                pRequest(request);</span>
<span class="fc" id="L134">            }</span>
<span class="fc" id="L135">        } catch (RequestProcessorException e) {</span>
<span class="pc bpc" id="L136" title="1 of 2 branches missed.">            if (e.getCause() instanceof XidRolloverException) {</span>
<span class="fc" id="L137">                LOG.info(e.getCause().getMessage());</span>
            }
<span class="fc" id="L139">            handleException(this.getName(), e);</span>
<span class="nc" id="L140">        } catch (Exception e) {</span>
<span class="nc" id="L141">            handleException(this.getName(), e);</span>
<span class="fc" id="L142">        }</span>
<span class="fc" id="L143">        LOG.info(&quot;PrepRequestProcessor exited loop!&quot;);</span>
<span class="fc" id="L144">    }</span>

    ChangeRecord getRecordForPath(String path) throws KeeperException.NoNodeException {
<span class="fc" id="L147">        ChangeRecord lastChange = null;</span>
<span class="fc" id="L148">        synchronized (zks.outstandingChanges) {</span>
<span class="fc" id="L149">            lastChange = zks.outstandingChangesForPath.get(path);</span>
<span class="fc bfc" id="L150" title="All 2 branches covered.">            if (lastChange == null) {</span>
<span class="fc" id="L151">                DataNode n = zks.getZKDatabase().getNode(path);</span>
<span class="fc bfc" id="L152" title="All 2 branches covered.">                if (n != null) {</span>
                    Long acl;
                    Set&lt;String&gt; children;
<span class="fc" id="L155">                    synchronized(n) {</span>
<span class="fc" id="L156">                        acl = n.acl;</span>
<span class="fc" id="L157">                        children = n.getChildren();</span>
<span class="pc" id="L158">                    }</span>
<span class="fc bfc" id="L159" title="All 2 branches covered.">                    lastChange = new ChangeRecord(-1, path, n.stat,</span>
<span class="fc" id="L160">                        children != null ? children.size() : 0,</span>
<span class="fc" id="L161">                            zks.getZKDatabase().convertLong(acl));</span>
                }
            }
<span class="pc" id="L164">        }</span>
<span class="fc bfc" id="L165" title="All 4 branches covered.">        if (lastChange == null || lastChange.stat == null) {</span>
<span class="fc" id="L166">            throw new KeeperException.NoNodeException(path);</span>
        }
<span class="fc" id="L168">        return lastChange;</span>
    }

    private ChangeRecord getOutstandingChange(String path) {
<span class="fc" id="L172">        synchronized (zks.outstandingChanges) {</span>
<span class="fc" id="L173">            return zks.outstandingChangesForPath.get(path);</span>
<span class="nc" id="L174">        }</span>
    }

    void addChangeRecord(ChangeRecord c) {
<span class="fc" id="L178">        synchronized (zks.outstandingChanges) {</span>
<span class="fc" id="L179">            zks.outstandingChanges.add(c);</span>
<span class="fc" id="L180">            zks.outstandingChangesForPath.put(c.path, c);</span>
<span class="pc" id="L181">        }</span>
<span class="fc" id="L182">    }</span>

    /**
     * Grab current pending change records for each op in a multi-op.
     * 
     * This is used inside MultiOp error code path to rollback in the event
     * of a failed multi-op.
     *
     * @param multiRequest
     * @return a map that contains previously existed records that probably need to be
     *         rolled back in any failure.
     */
    HashMap&lt;String, ChangeRecord&gt; getPendingChanges(MultiTransactionRecord multiRequest) {
<span class="fc" id="L195">        HashMap&lt;String, ChangeRecord&gt; pendingChangeRecords = new HashMap&lt;String, ChangeRecord&gt;();</span>

<span class="fc bfc" id="L197" title="All 2 branches covered.">        for (Op op : multiRequest) {</span>
<span class="fc" id="L198">            String path = op.getPath();</span>
<span class="fc" id="L199">            ChangeRecord cr = getOutstandingChange(path);</span>
            // only previously existing records need to be rolled back.
<span class="fc bfc" id="L201" title="All 2 branches covered.">            if (cr != null) {</span>
<span class="fc" id="L202">                pendingChangeRecords.put(path, cr);</span>
            }

            /*
             * ZOOKEEPER-1624 - We need to store for parent's ChangeRecord
             * of the parent node of a request. So that if this is a
             * sequential node creation request, rollbackPendingChanges()
             * can restore previous parent's ChangeRecord correctly.
             *
             * Otherwise, sequential node name generation will be incorrect
             * for a subsequent request.
             */
<span class="fc" id="L214">            int lastSlash = path.lastIndexOf('/');</span>
<span class="pc bpc" id="L215" title="2 of 4 branches missed.">            if (lastSlash == -1 || path.indexOf('\0') != -1) {</span>
<span class="nc" id="L216">                continue;</span>
            }
<span class="fc" id="L218">            String parentPath = path.substring(0, lastSlash);</span>
<span class="fc" id="L219">            ChangeRecord parentCr = getOutstandingChange(parentPath);</span>
<span class="fc bfc" id="L220" title="All 2 branches covered.">            if (parentCr != null) {</span>
<span class="fc" id="L221">                pendingChangeRecords.put(parentPath, parentCr);</span>
            }
<span class="fc" id="L223">        }</span>

<span class="fc" id="L225">        return pendingChangeRecords;</span>
    }

    /**
     * Rollback pending changes records from a failed multi-op.
     *
     * If a multi-op fails, we can't leave any invalid change records we created
     * around. We also need to restore their prior value (if any) if their prior
     * value is still valid.
     *
     * @param zxid
     * @param pendingChangeRecords
     */
    void rollbackPendingChanges(long zxid, HashMap&lt;String, ChangeRecord&gt;pendingChangeRecords) {
<span class="fc" id="L239">        synchronized (zks.outstandingChanges) {</span>
            // Grab a list iterator starting at the END of the list so we can iterate in reverse
<span class="fc" id="L241">            ListIterator&lt;ChangeRecord&gt; iter = zks.outstandingChanges.listIterator(zks.outstandingChanges.size());</span>
<span class="fc bfc" id="L242" title="All 2 branches covered.">            while (iter.hasPrevious()) {</span>
<span class="fc" id="L243">                ChangeRecord c = iter.previous();</span>
<span class="fc bfc" id="L244" title="All 2 branches covered.">                if (c.zxid == zxid) {</span>
<span class="fc" id="L245">                    iter.remove();</span>
                    // Remove all outstanding changes for paths of this multi.
                    // Previous records will be added back later.
<span class="fc" id="L248">                    zks.outstandingChangesForPath.remove(c.path);</span>
                } else {
                    break;
                }
<span class="fc" id="L252">            }</span>

            // we don't need to roll back any records because there is nothing left.
<span class="fc bfc" id="L255" title="All 2 branches covered.">            if (zks.outstandingChanges.isEmpty()) {</span>
<span class="fc" id="L256">                return;</span>
            }

<span class="fc" id="L259">            long firstZxid = zks.outstandingChanges.get(0).zxid;</span>

<span class="fc bfc" id="L261" title="All 2 branches covered.">            for (ChangeRecord c : pendingChangeRecords.values()) {</span>
                // Don't apply any prior change records less than firstZxid.
                // Note that previous outstanding requests might have been removed
                // once they are completed.
<span class="pc bpc" id="L265" title="1 of 2 branches missed.">                if (c.zxid &lt; firstZxid) {</span>
<span class="nc" id="L266">                    continue;</span>
                }

                // add previously existing records back.
<span class="fc" id="L270">                zks.outstandingChangesForPath.put(c.path, c);</span>
<span class="fc" id="L271">            }</span>
<span class="pc" id="L272">        }</span>
<span class="fc" id="L273">    }</span>

    static void checkACL(ZooKeeperServer zks, List&lt;ACL&gt; acl, int perm,
            List&lt;Id&gt; ids) throws KeeperException.NoAuthException {
<span class="pc bpc" id="L277" title="1 of 2 branches missed.">        if (skipACL) {</span>
<span class="nc" id="L278">            return;</span>
        }
<span class="pc bpc" id="L280" title="2 of 4 branches missed.">        if (acl == null || acl.size() == 0) {</span>
<span class="nc" id="L281">            return;</span>
        }
<span class="fc bfc" id="L283" title="All 2 branches covered.">        for (Id authId : ids) {</span>
<span class="fc bfc" id="L284" title="All 2 branches covered.">            if (authId.getScheme().equals(&quot;super&quot;)) {</span>
<span class="fc" id="L285">                return;</span>
            }
<span class="fc" id="L287">        }</span>
<span class="fc bfc" id="L288" title="All 2 branches covered.">        for (ACL a : acl) {</span>
<span class="fc" id="L289">            Id id = a.getId();</span>
<span class="fc bfc" id="L290" title="All 2 branches covered.">            if ((a.getPerms() &amp; perm) != 0) {</span>
<span class="fc bfc" id="L291" title="All 2 branches covered.">                if (id.getScheme().equals(&quot;world&quot;)</span>
<span class="pc bpc" id="L292" title="1 of 2 branches missed.">                        &amp;&amp; id.getId().equals(&quot;anyone&quot;)) {</span>
<span class="fc" id="L293">                    return;</span>
                }
<span class="fc" id="L295">                AuthenticationProvider ap = ProviderRegistry.getProvider(id</span>
<span class="fc" id="L296">                        .getScheme());</span>
<span class="pc bpc" id="L297" title="1 of 2 branches missed.">                if (ap != null) {</span>
<span class="fc bfc" id="L298" title="All 2 branches covered.">                    for (Id authId : ids) {                        </span>
<span class="fc bfc" id="L299" title="All 2 branches covered.">                        if (authId.getScheme().equals(id.getScheme())</span>
<span class="fc bfc" id="L300" title="All 2 branches covered.">                                &amp;&amp; ap.matches(authId.getId(), id.getId())) {</span>
<span class="fc" id="L301">                            return;</span>
                        }
<span class="fc" id="L303">                    }</span>
                }
            }
<span class="fc" id="L306">        }</span>
<span class="fc" id="L307">        throw new KeeperException.NoAuthException();</span>
    }

    /**
     * This method will be called inside the ProcessRequestThread, which is a
     * singleton, so there will be a single thread calling this code.
     *
     * @param type
     * @param zxid
     * @param request
     * @param record
     */
    @SuppressWarnings(&quot;unchecked&quot;)
    protected void pRequest2Txn(int type, long zxid, Request request, Record record, boolean deserialize)
        throws KeeperException, IOException, RequestProcessorException
    {
<span class="fc" id="L323">        request.hdr = new TxnHeader(request.sessionId, request.cxid, zxid,</span>
<span class="fc" id="L324">                                    zks.getTime(), type);</span>

<span class="pc bpc" id="L326" title="1 of 8 branches missed.">        switch (type) {</span>
            case OpCode.create:                
<span class="fc" id="L328">                zks.sessionTracker.checkSession(request.sessionId, request.getOwner());</span>
<span class="fc" id="L329">                CreateRequest createRequest = (CreateRequest)record;   </span>
<span class="fc bfc" id="L330" title="All 2 branches covered.">                if(deserialize)</span>
<span class="fc" id="L331">                    ByteBufferInputStream.byteBuffer2Record(request.request, createRequest);</span>
<span class="fc" id="L332">                String path = createRequest.getPath();</span>
<span class="fc" id="L333">                int lastSlash = path.lastIndexOf('/');</span>
<span class="pc bpc" id="L334" title="2 of 6 branches missed.">                if (lastSlash == -1 || path.indexOf('\0') != -1 || failCreate) {</span>
<span class="fc" id="L335">                    LOG.info(&quot;Invalid path &quot; + path + &quot; with session 0x&quot; +</span>
<span class="fc" id="L336">                            Long.toHexString(request.sessionId));</span>
<span class="fc" id="L337">                    throw new KeeperException.BadArgumentsException(path);</span>
                }
<span class="fc" id="L339">                List&lt;ACL&gt; listACL = removeDuplicates(createRequest.getAcl());</span>
<span class="fc bfc" id="L340" title="All 2 branches covered.">                if (!fixupACL(request.authInfo, listACL)) {</span>
<span class="fc" id="L341">                    throw new KeeperException.InvalidACLException(path);</span>
                }
<span class="fc" id="L343">                String parentPath = path.substring(0, lastSlash);</span>
<span class="fc" id="L344">                ChangeRecord parentRecord = getRecordForPath(parentPath);</span>

<span class="fc" id="L346">                checkACL(zks, parentRecord.acl, ZooDefs.Perms.CREATE,</span>
                        request.authInfo);
<span class="fc" id="L348">                int parentCVersion = parentRecord.stat.getCversion();</span>
<span class="fc" id="L349">                CreateMode createMode =</span>
<span class="fc" id="L350">                    CreateMode.fromFlag(createRequest.getFlags());</span>
<span class="fc bfc" id="L351" title="All 2 branches covered.">                if (createMode.isSequential()) {</span>
<span class="fc" id="L352">                    path = path + String.format(Locale.ENGLISH, &quot;%010d&quot;, parentCVersion);</span>
                }
<span class="fc" id="L354">                validatePath(path, request.sessionId);</span>
                try {
<span class="pc bpc" id="L356" title="1 of 2 branches missed.">                    if (getRecordForPath(path) != null) {</span>
<span class="fc" id="L357">                        throw new KeeperException.NodeExistsException(path);</span>
                    }
<span class="fc" id="L359">                } catch (KeeperException.NoNodeException e) {</span>
                    // ignore this one
<span class="nc" id="L361">                }</span>
<span class="fc bfc" id="L362" title="All 2 branches covered.">                boolean ephemeralParent = parentRecord.stat.getEphemeralOwner() != 0;</span>
<span class="fc bfc" id="L363" title="All 2 branches covered.">                if (ephemeralParent) {</span>
<span class="fc" id="L364">                    throw new KeeperException.NoChildrenForEphemeralsException(path);</span>
                }
<span class="fc" id="L366">                int newCversion = parentRecord.stat.getCversion()+1;</span>
<span class="fc" id="L367">                request.txn = new CreateTxn(path, createRequest.getData(),</span>
                        listACL,
<span class="fc" id="L369">                        createMode.isEphemeral(), newCversion);</span>
<span class="fc" id="L370">                StatPersisted s = new StatPersisted();</span>
<span class="fc bfc" id="L371" title="All 2 branches covered.">                if (createMode.isEphemeral()) {</span>
<span class="fc" id="L372">                    s.setEphemeralOwner(request.sessionId);</span>
                }
<span class="fc" id="L374">                parentRecord = parentRecord.duplicate(request.hdr.getZxid());</span>
<span class="fc" id="L375">                parentRecord.childCount++;</span>
<span class="fc" id="L376">                parentRecord.stat.setCversion(newCversion);</span>
<span class="fc" id="L377">                addChangeRecord(parentRecord);</span>
<span class="fc" id="L378">                addChangeRecord(new ChangeRecord(request.hdr.getZxid(), path, s,</span>
                        0, listACL));
<span class="fc" id="L380">                break;</span>
            case OpCode.delete:
<span class="fc" id="L382">                zks.sessionTracker.checkSession(request.sessionId, request.getOwner());</span>
<span class="fc" id="L383">                DeleteRequest deleteRequest = (DeleteRequest)record;</span>
<span class="fc bfc" id="L384" title="All 2 branches covered.">                if(deserialize)</span>
<span class="fc" id="L385">                    ByteBufferInputStream.byteBuffer2Record(request.request, deleteRequest);</span>
<span class="fc" id="L386">                path = deleteRequest.getPath();</span>
<span class="fc" id="L387">                lastSlash = path.lastIndexOf('/');</span>
<span class="pc bpc" id="L388" title="2 of 4 branches missed.">                if (lastSlash == -1 || path.indexOf('\0') != -1</span>
<span class="fc bfc" id="L389" title="All 2 branches covered.">                        || zks.getZKDatabase().isSpecialPath(path)) {</span>
<span class="fc" id="L390">                    throw new KeeperException.BadArgumentsException(path);</span>
                }
<span class="fc" id="L392">                parentPath = path.substring(0, lastSlash);</span>
<span class="fc" id="L393">                parentRecord = getRecordForPath(parentPath);</span>
<span class="fc" id="L394">                ChangeRecord nodeRecord = getRecordForPath(path);</span>
<span class="fc" id="L395">                checkACL(zks, parentRecord.acl, ZooDefs.Perms.DELETE,</span>
                        request.authInfo);
<span class="fc" id="L397">                int version = deleteRequest.getVersion();</span>
<span class="fc bfc" id="L398" title="All 4 branches covered.">                if (version != -1 &amp;&amp; nodeRecord.stat.getVersion() != version) {</span>
<span class="fc" id="L399">                    throw new KeeperException.BadVersionException(path);</span>
                }
<span class="fc bfc" id="L401" title="All 2 branches covered.">                if (nodeRecord.childCount &gt; 0) {</span>
<span class="fc" id="L402">                    throw new KeeperException.NotEmptyException(path);</span>
                }
<span class="fc" id="L404">                request.txn = new DeleteTxn(path);</span>
<span class="fc" id="L405">                parentRecord = parentRecord.duplicate(request.hdr.getZxid());</span>
<span class="fc" id="L406">                parentRecord.childCount--;</span>
<span class="fc" id="L407">                addChangeRecord(parentRecord);</span>
<span class="fc" id="L408">                addChangeRecord(new ChangeRecord(request.hdr.getZxid(), path,</span>
                        null, -1, null));
<span class="fc" id="L410">                break;</span>
            case OpCode.setData:
<span class="fc" id="L412">                zks.sessionTracker.checkSession(request.sessionId, request.getOwner());</span>
<span class="fc" id="L413">                SetDataRequest setDataRequest = (SetDataRequest)record;</span>
<span class="fc bfc" id="L414" title="All 2 branches covered.">                if(deserialize)</span>
<span class="fc" id="L415">                    ByteBufferInputStream.byteBuffer2Record(request.request, setDataRequest);</span>
<span class="fc" id="L416">                path = setDataRequest.getPath();</span>
<span class="fc" id="L417">                validatePath(path, request.sessionId);</span>
<span class="fc" id="L418">                nodeRecord = getRecordForPath(path);</span>
<span class="fc" id="L419">                checkACL(zks, nodeRecord.acl, ZooDefs.Perms.WRITE,</span>
                        request.authInfo);
<span class="fc" id="L421">                version = setDataRequest.getVersion();</span>
<span class="fc" id="L422">                int currentVersion = nodeRecord.stat.getVersion();</span>
<span class="fc bfc" id="L423" title="All 4 branches covered.">                if (version != -1 &amp;&amp; version != currentVersion) {</span>
<span class="fc" id="L424">                    throw new KeeperException.BadVersionException(path);</span>
                }
<span class="fc" id="L426">                version = currentVersion + 1;</span>
<span class="fc" id="L427">                request.txn = new SetDataTxn(path, setDataRequest.getData(), version);</span>
<span class="fc" id="L428">                nodeRecord = nodeRecord.duplicate(request.hdr.getZxid());</span>
<span class="fc" id="L429">                nodeRecord.stat.setVersion(version);</span>
<span class="fc" id="L430">                addChangeRecord(nodeRecord);</span>
<span class="fc" id="L431">                break;</span>
            case OpCode.setACL:
<span class="fc" id="L433">                zks.sessionTracker.checkSession(request.sessionId, request.getOwner());</span>
<span class="fc" id="L434">                SetACLRequest setAclRequest = (SetACLRequest)record;</span>
<span class="pc bpc" id="L435" title="1 of 2 branches missed.">                if(deserialize)</span>
<span class="fc" id="L436">                    ByteBufferInputStream.byteBuffer2Record(request.request, setAclRequest);</span>
<span class="fc" id="L437">                path = setAclRequest.getPath();</span>
<span class="fc" id="L438">                validatePath(path, request.sessionId);</span>
<span class="fc" id="L439">                listACL = removeDuplicates(setAclRequest.getAcl());</span>
<span class="pc bpc" id="L440" title="1 of 2 branches missed.">                if (!fixupACL(request.authInfo, listACL)) {</span>
<span class="nc" id="L441">                    throw new KeeperException.InvalidACLException(path);</span>
                }
<span class="fc" id="L443">                nodeRecord = getRecordForPath(path);</span>
<span class="fc" id="L444">                checkACL(zks, nodeRecord.acl, ZooDefs.Perms.ADMIN,</span>
                        request.authInfo);
<span class="fc" id="L446">                version = setAclRequest.getVersion();</span>
<span class="fc" id="L447">                currentVersion = nodeRecord.stat.getAversion();</span>
<span class="fc bfc" id="L448" title="All 4 branches covered.">                if (version != -1 &amp;&amp; version != currentVersion) {</span>
<span class="fc" id="L449">                    throw new KeeperException.BadVersionException(path);</span>
                }
<span class="fc" id="L451">                version = currentVersion + 1;</span>
<span class="fc" id="L452">                request.txn = new SetACLTxn(path, listACL, version);</span>
<span class="fc" id="L453">                nodeRecord = nodeRecord.duplicate(request.hdr.getZxid());</span>
<span class="fc" id="L454">                nodeRecord.stat.setAversion(version);</span>
<span class="fc" id="L455">                addChangeRecord(nodeRecord);</span>
<span class="fc" id="L456">                break;</span>
            case OpCode.createSession:
<span class="fc" id="L458">                request.request.rewind();</span>
<span class="fc" id="L459">                int to = request.request.getInt();</span>
<span class="fc" id="L460">                request.txn = new CreateSessionTxn(to);</span>
<span class="fc" id="L461">                request.request.rewind();</span>
<span class="fc" id="L462">                zks.sessionTracker.addSession(request.sessionId, to);</span>
<span class="fc" id="L463">                zks.setOwner(request.sessionId, request.getOwner());</span>
<span class="fc" id="L464">                break;</span>
            case OpCode.closeSession:
                // We don't want to do this check since the session expiration thread
                // queues up this operation without being the session owner.
                // this request is the last of the session so it should be ok
                //zks.sessionTracker.checkSession(request.sessionId, request.getOwner());
<span class="fc" id="L470">                HashSet&lt;String&gt; es = zks.getZKDatabase()</span>
<span class="fc" id="L471">                        .getEphemerals(request.sessionId);</span>
<span class="fc" id="L472">                synchronized (zks.outstandingChanges) {</span>
<span class="fc bfc" id="L473" title="All 2 branches covered.">                    for (ChangeRecord c : zks.outstandingChanges) {</span>
<span class="fc bfc" id="L474" title="All 2 branches covered.">                        if (c.stat == null) {</span>
                            // Doing a delete
<span class="fc" id="L476">                            es.remove(c.path);</span>
<span class="pc bpc" id="L477" title="1 of 2 branches missed.">                        } else if (c.stat.getEphemeralOwner() == request.sessionId) {</span>
<span class="nc" id="L478">                            es.add(c.path);</span>
                        }
<span class="fc" id="L480">                    }</span>
<span class="fc bfc" id="L481" title="All 2 branches covered.">                    for (String path2Delete : es) {</span>
<span class="fc" id="L482">                        addChangeRecord(new ChangeRecord(request.hdr.getZxid(),</span>
                                path2Delete, null, 0, null));
<span class="fc" id="L484">                    }</span>

<span class="fc" id="L486">                    zks.sessionTracker.setSessionClosing(request.sessionId);</span>
<span class="pc" id="L487">                }</span>

<span class="fc" id="L489">                LOG.info(&quot;Processed session termination for sessionid: 0x&quot;</span>
<span class="fc" id="L490">                        + Long.toHexString(request.sessionId));</span>
<span class="fc" id="L491">                break;</span>
            case OpCode.check:
<span class="fc" id="L493">                zks.sessionTracker.checkSession(request.sessionId, request.getOwner());</span>
<span class="fc" id="L494">                CheckVersionRequest checkVersionRequest = (CheckVersionRequest)record;</span>
<span class="pc bpc" id="L495" title="1 of 2 branches missed.">                if(deserialize)</span>
<span class="nc" id="L496">                    ByteBufferInputStream.byteBuffer2Record(request.request, checkVersionRequest);</span>
<span class="fc" id="L497">                path = checkVersionRequest.getPath();</span>
<span class="fc" id="L498">                validatePath(path, request.sessionId);</span>
<span class="fc" id="L499">                nodeRecord = getRecordForPath(path);</span>
<span class="fc" id="L500">                checkACL(zks, nodeRecord.acl, ZooDefs.Perms.READ,</span>
                        request.authInfo);
<span class="fc" id="L502">                version = checkVersionRequest.getVersion();</span>
<span class="fc" id="L503">                currentVersion = nodeRecord.stat.getVersion();</span>
<span class="pc bpc" id="L504" title="1 of 4 branches missed.">                if (version != -1 &amp;&amp; version != currentVersion) {</span>
<span class="fc" id="L505">                    throw new KeeperException.BadVersionException(path);</span>
                }
<span class="fc" id="L507">                version = currentVersion + 1;</span>
<span class="fc" id="L508">                request.txn = new CheckVersionTxn(path, version);</span>
                break;
        }
<span class="fc" id="L511">    }</span>

    private void validatePath(String path, long sessionId) throws BadArgumentsException {
        try {
<span class="fc" id="L515">            PathUtils.validatePath(path);</span>
<span class="fc" id="L516">        } catch(IllegalArgumentException ie) {</span>
<span class="fc" id="L517">            LOG.info(&quot;Invalid path &quot; +  path + &quot; with session 0x&quot; + Long.toHexString(sessionId) +</span>
<span class="fc" id="L518">                    &quot;, reason: &quot; + ie.getMessage());</span>
<span class="fc" id="L519">            throw new BadArgumentsException(path);</span>
<span class="fc" id="L520">        }</span>
<span class="fc" id="L521">    }</span>

    /**
     * This method will be called inside the ProcessRequestThread, which is a
     * singleton, so there will be a single thread calling this code.
     *
     * @param request
     */
    @SuppressWarnings(&quot;unchecked&quot;)
    protected void pRequest(Request request) throws RequestProcessorException {
        // LOG.info(&quot;Prep&gt;&gt;&gt; cxid = &quot; + request.cxid + &quot; type = &quot; +
        // request.type + &quot; id = 0x&quot; + Long.toHexString(request.sessionId));
<span class="fc" id="L533">        request.hdr = null;</span>
<span class="fc" id="L534">        request.txn = null;</span>
        
        try {
<span class="pc bpc" id="L537" title="2 of 9 branches missed.">            switch (request.type) {</span>
                case OpCode.create:
<span class="fc" id="L539">                CreateRequest createRequest = new CreateRequest();</span>
<span class="fc" id="L540">                pRequest2Txn(request.type, zks.getNextZxid(), request, createRequest, true);</span>
<span class="fc" id="L541">                break;</span>
            case OpCode.delete:
<span class="fc" id="L543">                DeleteRequest deleteRequest = new DeleteRequest();               </span>
<span class="fc" id="L544">                pRequest2Txn(request.type, zks.getNextZxid(), request, deleteRequest, true);</span>
<span class="fc" id="L545">                break;</span>
            case OpCode.setData:
<span class="fc" id="L547">                SetDataRequest setDataRequest = new SetDataRequest();                </span>
<span class="fc" id="L548">                pRequest2Txn(request.type, zks.getNextZxid(), request, setDataRequest, true);</span>
<span class="fc" id="L549">                break;</span>
            case OpCode.setACL:
<span class="fc" id="L551">                SetACLRequest setAclRequest = new SetACLRequest();                </span>
<span class="fc" id="L552">                pRequest2Txn(request.type, zks.getNextZxid(), request, setAclRequest, true);</span>
<span class="fc" id="L553">                break;</span>
            case OpCode.check:
<span class="nc" id="L555">                CheckVersionRequest checkRequest = new CheckVersionRequest();              </span>
<span class="nc" id="L556">                pRequest2Txn(request.type, zks.getNextZxid(), request, checkRequest, true);</span>
<span class="nc" id="L557">                break;</span>
            case OpCode.multi:
<span class="fc" id="L559">                MultiTransactionRecord multiRequest = new MultiTransactionRecord();</span>
                try {
<span class="fc" id="L561">                    ByteBufferInputStream.byteBuffer2Record(request.request, multiRequest);</span>
<span class="nc" id="L562">                } catch(IOException e) {</span>
<span class="nc" id="L563">                   request.hdr =  new TxnHeader(request.sessionId, request.cxid, zks.getNextZxid(),</span>
<span class="nc" id="L564">                            zks.getTime(), OpCode.multi);</span>
<span class="nc" id="L565">                   throw e;</span>
<span class="fc" id="L566">                }</span>
<span class="fc" id="L567">                List&lt;Txn&gt; txns = new ArrayList&lt;Txn&gt;();</span>
                //Each op in a multi-op must have the same zxid!
<span class="fc" id="L569">                long zxid = zks.getNextZxid();</span>
<span class="fc" id="L570">                KeeperException ke = null;</span>

                //Store off current pending change records in case we need to rollback
<span class="fc" id="L573">                HashMap&lt;String, ChangeRecord&gt; pendingChanges = getPendingChanges(multiRequest);</span>

<span class="fc" id="L575">                int index = 0;</span>
<span class="fc bfc" id="L576" title="All 2 branches covered.">                for(Op op: multiRequest) {</span>
<span class="fc" id="L577">                    Record subrequest = op.toRequestRecord() ;</span>

                    /* If we've already failed one of the ops, don't bother
                     * trying the rest as we know it's going to fail and it
                     * would be confusing in the logfiles.
                     */
<span class="fc bfc" id="L583" title="All 2 branches covered.">                    if (ke != null) {</span>
<span class="fc" id="L584">                        request.hdr.setType(OpCode.error);</span>
<span class="fc" id="L585">                        request.txn = new ErrorTxn(Code.RUNTIMEINCONSISTENCY.intValue());</span>
                    } 
                    
                    /* Prep the request and convert to a Txn */
                    else {
                        try {
<span class="fc" id="L591">                            pRequest2Txn(op.getType(), zxid, request, subrequest, false);</span>
<span class="fc" id="L592">                        } catch (KeeperException e) {</span>
<span class="pc bpc" id="L593" title="1 of 2 branches missed.">                            if (ke == null) {</span>
<span class="fc" id="L594">                                ke = e;</span>
                            }
<span class="fc" id="L596">                            request.hdr.setType(OpCode.error);</span>
<span class="fc" id="L597">                            request.txn = new ErrorTxn(e.code().intValue());</span>
<span class="fc" id="L598">                            LOG.info(&quot;Got user-level KeeperException when processing &quot;</span>
<span class="fc" id="L599">                            		+ request.toString() + &quot; aborting remaining multi ops.&quot;</span>
<span class="fc" id="L600">                            		+ &quot; Error Path:&quot; + e.getPath()</span>
<span class="fc" id="L601">                            		+ &quot; Error:&quot; + e.getMessage());</span>

<span class="fc" id="L603">                            request.setException(e);</span>

                            /* Rollback change records from failed multi-op */
<span class="fc" id="L606">                            rollbackPendingChanges(zxid, pendingChanges);</span>
<span class="fc" id="L607">                        }</span>
                    }

                    //FIXME: I don't want to have to serialize it here and then
                    //       immediately deserialize in next processor. But I'm 
                    //       not sure how else to get the txn stored into our list.
<span class="fc" id="L613">                    ByteArrayOutputStream baos = new ByteArrayOutputStream();</span>
<span class="fc" id="L614">                    BinaryOutputArchive boa = BinaryOutputArchive.getArchive(baos);</span>
<span class="fc" id="L615">                    request.txn.serialize(boa, &quot;request&quot;) ;</span>
<span class="fc" id="L616">                    ByteBuffer bb = ByteBuffer.wrap(baos.toByteArray());</span>

<span class="fc" id="L618">                    txns.add(new Txn(request.hdr.getType(), bb.array()));</span>
<span class="fc" id="L619">                    index++;</span>
<span class="fc" id="L620">                }</span>

<span class="fc" id="L622">                request.hdr = new TxnHeader(request.sessionId, request.cxid, zxid, zks.getTime(), request.type);</span>
<span class="fc" id="L623">                request.txn = new MultiTxn(txns);</span>
                
<span class="fc" id="L625">                break;</span>

            //create/close session don't require request record
            case OpCode.createSession:
            case OpCode.closeSession:
<span class="fc" id="L630">                pRequest2Txn(request.type, zks.getNextZxid(), request, null, true);</span>
<span class="fc" id="L631">                break;</span>
 
            //All the rest don't need to create a Txn - just verify session
            case OpCode.sync:
            case OpCode.exists:
            case OpCode.getData:
            case OpCode.getACL:
            case OpCode.getChildren:
            case OpCode.getChildren2:
            case OpCode.ping:
            case OpCode.setWatches:
<span class="fc" id="L642">                zks.sessionTracker.checkSession(request.sessionId,</span>
<span class="fc" id="L643">                        request.getOwner());</span>
                break;
            }
<span class="fc" id="L646">        } catch (KeeperException e) {</span>
<span class="pc bpc" id="L647" title="1 of 2 branches missed.">            if (request.hdr != null) {</span>
<span class="fc" id="L648">                request.hdr.setType(OpCode.error);</span>
<span class="fc" id="L649">                request.txn = new ErrorTxn(e.code().intValue());</span>
            }
<span class="fc" id="L651">            LOG.info(&quot;Got user-level KeeperException when processing &quot;</span>
<span class="fc" id="L652">                    + request.toString()</span>
<span class="fc" id="L653">                    + &quot; Error Path:&quot; + e.getPath()</span>
<span class="fc" id="L654">                    + &quot; Error:&quot; + e.getMessage());</span>
<span class="fc" id="L655">            request.setException(e);</span>
<span class="fc" id="L656">        } catch (Exception e) {</span>
            // log at error level as we are returning a marshalling
            // error to the user
<span class="fc" id="L659">            LOG.error(&quot;Failed to process &quot; + request, e);</span>

<span class="fc" id="L661">            StringBuilder sb = new StringBuilder();</span>
<span class="fc" id="L662">            ByteBuffer bb = request.request;</span>
<span class="pc bpc" id="L663" title="1 of 2 branches missed.">            if(bb != null){</span>
<span class="fc" id="L664">                bb.rewind();</span>
<span class="fc bfc" id="L665" title="All 2 branches covered.">                while (bb.hasRemaining()) {</span>
<span class="fc" id="L666">                    sb.append(Integer.toHexString(bb.get() &amp; 0xff));</span>
                }
            } else {
<span class="nc" id="L669">                sb.append(&quot;request buffer is null&quot;);</span>
            }

<span class="fc" id="L672">            LOG.error(&quot;Dumping request buffer: 0x&quot; + sb.toString());</span>
<span class="pc bpc" id="L673" title="1 of 2 branches missed.">            if (request.hdr != null) {</span>
<span class="fc" id="L674">                request.hdr.setType(OpCode.error);</span>
<span class="fc" id="L675">                request.txn = new ErrorTxn(Code.MARSHALLINGERROR.intValue());</span>
            }
<span class="fc" id="L677">        }</span>
<span class="fc" id="L678">        request.zxid = zks.getZxid();</span>
<span class="fc" id="L679">        nextProcessor.processRequest(request);</span>
<span class="fc" id="L680">    }</span>

    private List&lt;ACL&gt; removeDuplicates(List&lt;ACL&gt; acl) {

<span class="fc" id="L684">        ArrayList&lt;ACL&gt; retval = new ArrayList&lt;ACL&gt;();</span>
<span class="fc" id="L685">        Iterator&lt;ACL&gt; it = acl.iterator();</span>
<span class="fc bfc" id="L686" title="All 2 branches covered.">        while (it.hasNext()) {</span>
<span class="fc" id="L687">            ACL a = it.next();</span>
<span class="fc bfc" id="L688" title="All 2 branches covered.">            if (retval.contains(a) == false) {</span>
<span class="fc" id="L689">                retval.add(a);</span>
            }
<span class="fc" id="L691">        }</span>
<span class="fc" id="L692">        return retval;</span>
    }


    /**
     * This method checks out the acl making sure it isn't null or empty,
     * it has valid schemes and ids, and expanding any relative ids that
     * depend on the requestor's authentication information.
     *
     * @param authInfo list of ACL IDs associated with the client connection
     * @param acl list of ACLs being assigned to the node (create or setACL operation)
     * @return
     */
    private boolean fixupACL(List&lt;Id&gt; authInfo, List&lt;ACL&gt; acl) {
<span class="pc bpc" id="L706" title="1 of 2 branches missed.">        if (skipACL) {</span>
<span class="nc" id="L707">            return true;</span>
        }
<span class="pc bpc" id="L709" title="2 of 4 branches missed.">        if (acl == null || acl.size() == 0) {</span>
<span class="nc" id="L710">            return false;</span>
        }

<span class="fc" id="L713">        Iterator&lt;ACL&gt; it = acl.iterator();</span>
<span class="fc" id="L714">        LinkedList&lt;ACL&gt; toAdd = null;</span>
<span class="fc bfc" id="L715" title="All 2 branches covered.">        while (it.hasNext()) {</span>
<span class="fc" id="L716">            ACL a = it.next();</span>
<span class="fc" id="L717">            Id id = a.getId();</span>
<span class="pc bpc" id="L718" title="1 of 4 branches missed.">            if (id.getScheme().equals(&quot;world&quot;) &amp;&amp; id.getId().equals(&quot;anyone&quot;)) {</span>
                // wide open
<span class="fc bfc" id="L720" title="All 2 branches covered.">            } else if (id.getScheme().equals(&quot;auth&quot;)) {</span>
                // This is the &quot;auth&quot; id, so we have to expand it to the
                // authenticated ids of the requestor
<span class="fc" id="L723">                it.remove();</span>
<span class="pc bpc" id="L724" title="1 of 2 branches missed.">                if (toAdd == null) {</span>
<span class="fc" id="L725">                    toAdd = new LinkedList&lt;ACL&gt;();</span>
                }
<span class="fc" id="L727">                boolean authIdValid = false;</span>
<span class="fc bfc" id="L728" title="All 2 branches covered.">                for (Id cid : authInfo) {</span>
<span class="fc" id="L729">                    AuthenticationProvider ap =</span>
<span class="fc" id="L730">                        ProviderRegistry.getProvider(cid.getScheme());</span>
<span class="fc bfc" id="L731" title="All 2 branches covered.">                    if (ap == null) {</span>
<span class="fc" id="L732">                        LOG.error(&quot;Missing AuthenticationProvider for &quot;</span>
<span class="fc" id="L733">                                + cid.getScheme());</span>
<span class="fc bfc" id="L734" title="All 2 branches covered.">                    } else if (ap.isAuthenticated()) {</span>
<span class="fc" id="L735">                        authIdValid = true;</span>
<span class="fc" id="L736">                        toAdd.add(new ACL(a.getPerms(), cid));</span>
                    }
<span class="fc" id="L738">                }</span>
<span class="fc bfc" id="L739" title="All 2 branches covered.">                if (!authIdValid) {</span>
<span class="fc" id="L740">                    return false;</span>
                }
<span class="fc" id="L742">            } else {</span>
<span class="fc" id="L743">                AuthenticationProvider ap = ProviderRegistry.getProvider(id</span>
<span class="fc" id="L744">                        .getScheme());</span>
<span class="pc bpc" id="L745" title="1 of 2 branches missed.">                if (ap == null) {</span>
<span class="nc" id="L746">                    return false;</span>
                }
<span class="fc bfc" id="L748" title="All 2 branches covered.">                if (!ap.isValid(id.getId())) {</span>
<span class="fc" id="L749">                    return false;</span>
                }
            }
<span class="fc" id="L752">        }</span>
<span class="fc bfc" id="L753" title="All 2 branches covered.">        if (toAdd != null) {</span>
<span class="fc bfc" id="L754" title="All 2 branches covered.">            for (ACL a : toAdd) {</span>
<span class="fc" id="L755">                acl.add(a);</span>
<span class="fc" id="L756">            }</span>
        }
<span class="pc bpc" id="L758" title="1 of 2 branches missed.">        return acl.size() &gt; 0;</span>
    }

    public void processRequest(Request request) {
        // request.addRQRec(&quot;&gt;prep=&quot;+zks.outstandingChanges.size());
<span class="fc" id="L763">        submittedRequests.add(request);</span>
<span class="fc" id="L764">    }</span>

    public void shutdown() {
<span class="fc" id="L767">        LOG.info(&quot;Shutting down&quot;);</span>
<span class="fc" id="L768">        submittedRequests.clear();</span>
<span class="fc" id="L769">        submittedRequests.add(Request.requestOfDeath);</span>
<span class="fc" id="L770">        nextProcessor.shutdown();</span>
<span class="fc" id="L771">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>